- Validity
	- Internal Validity, can be affected by
		1. research design, e.g descriptive, experimental, quasi-experimental and relationship-based
		2. threats to internal validity (literature: Campbell, 1963,1969; Campbell & Stanley, 1963; Cook & Campbell, 1979)
			1. History effects: events during the study which can change the outcome
			2. Maturation: change in peoples, short-term effects can include mood, tiredness, boredom, hunger, inattention, etc.
			3. Testing effects: difference in scores may be affected by the fact that they had a test. This includes Learning effects (practive or carry-over effects) and Experimental fatigue.
			4. Instrumentation: change in instrumentation over time
			5. Statistical regression: extreme data tend to converge towards the mean of the population
			6. Selection biases: quasi-experimental where groups are not similar
			7. Experimental mortality: drop out of experiment due to various reasons
			8. Causal time order: rare cases where the dependent variabel influence the independent variable
			9. Diffusion (or imitation) of treatmens: cross-contamination between groups
			10. Compensatory rivalry: The group with the less attractive intervention can exert additional effort in order to show that they are equal with the "cool" group.
			11. Demoralization: opposite of compensatory rivalry
			12. Compensation: rewards for participating
			13. Experimenter effects: Differences introduced by the researchers
			14. Subject effects: changes in subject behaviour due to them knowing they are part of a study
	- External validity, tells you something about how the results can be generalized (generelization to the population, and generalisation acress populations). Can be affected by;
		1. research design; 
		2. and potensial threats
			1. selection biases
			2. Constructs, methods and confounding: we have to narrow down broad concepts into constructs that can be measured. 
			3. The 'real world' versus the 'experimental world'
			4. History effects and maturation



#How it may effect our study
- internal validity
	1. history effects: relatively short period from pretest to posttest gives a low likelyhood of this effecting our results.
	2. maturation: long terms effects are not relevant for our study. Shortterm effect can however be. 
	3. Testing effects: Both groups were exposed to the same testing paradigm so this would not effect us. The learning effect could still be of concern though as the kids may have remembered and learned some of the questions from the pretest.
	4. The pretest and posttest were the same, so this does not seems relevant for our study.
	5. Statistical regression: extreme high scores on the pretest and low scores on the posttest may be an indication of regression towards the mean. However many of your questions were not multiple choice questions and are therefore less likely to introduce luckbased point in our tests.
	6. selection biases: analysis shows that the robotics group had a much higher mean on their pretest than the simulator group. This is something we really need to mention. We should also mention that the task of diving the kids were not random, but the assignment of group to robots or simulator was.
	7. mortality: we saw several student that did not participate in both session, this may be a problem in long studies. But I think we are in the clear.
	8. Casual time order: This is not relevant for our case.
	9. Diffusion: This is a real concern for us, since all the kids were in the same class and was very aware of what the other groups were doing. This manifested itself a perhaps a little disappointment in the simulator group.
	10. Compensatory rivalry: again this could be a real concern for us. Some of the kids in the simulator group were especially disappointed that they were not in the robotics group.
	11. Demoralization: perhaps even more of a concern than 10, but for the same reasons.
	12. Compensation: we used no compensation, so this is not a concern for us.
	13. Experimenter effects: we tried to mitigate this effect by alternating which group started in the two session.
	14. Subject effeckt: I dont think this very likely to have happened in our study, mainly because we dealt with kids, and they didnt seem to care for what we were investigating. :P
- external validity
	1. Selection biases: analysis has shown that the two groups had different starting point, however this bias came perhaps from the teacher in how she organized the groups. Another issue may be that we excluded those who scored the highest on the pretest
	2. Constructs, methods and confounding: in our case we looked at a broad concept (maths), but we should not make any conclusion regarding our results and its applicability to math in general as this would be in violation of construct validity, seen as we did not measure the concept of math but rather the construct of angles.
	3. The 'real world' versus the 'experimental world': our setup seems fairly similar to an ordinary school day at THIS so I don't think this is an issue for us.
	4. History effects and maturation: short duration of research period means this most likely did not effect us.


Bib:
Babbie, E. R. (2010). The Practice of Social Research, 12th edition. Cengage Learning.

Campbell, D. T. (1963). Social attitudes and other acquired behavioural dispositions. In S. Koch (Ed.). Psychology: A Study of Science (Vol. 6, pp. 94-172). New York: McGraw-Hill.

Campbell, D. T. (1969). Reforms as experiments. American Psychologist, 24: 409-429.

Campbell, D. T., & Stanley, J. C. (1963). Experimental and quasi-experimental designs for research on teaching. In N.L. Gage (Ed.). Handbook of Research on Teaching (pp.171-246). Chicago: Rand McNally.

Cook, T. D., & Campbell, D. T. (1979). Quasi-Experimentation: Design and Analysis Issues for Field Settings. Chicago: Rand-McNally, pp. 51-55.
